package MT::Plugin::CMSEntryContext;
use strict;
use MT;
use MT::Plugin;

our $VERSION = '0.1';

use base qw( MT::Plugin );

@MT::Plugin::CMSEntryContext::ISA = qw(MT::Plugin);

my $plugin = new MT::Plugin::CMSEntryContext({
    name => 'CMSEntryContext',
    description => 'Enable to use MT tag in edit_entry screen.',
    author_name => 'Junnama Noda',
    author_link => 'http://junnama.alfasado.net/online/',
    version     => $VERSION,
});

MT->add_plugin($plugin);

sub init_registry {
    my $plugin = shift;
    $plugin->registry({
        tags => {
            block => {
                'CMSEntryContext' => \&_cms_entry_ctx,
            },
        }
   });
}

sub _cms_entry_ctx {
    my ($ctx, $args, $cond) = @_;
    my $app = MT->instance();
    my $blog = $app->blog;
    my $q = $app->param;
    my $type = $q->param('_type');
    my $mode = $q->param('__mode');
    my $entry_id = $q->param('id');
    my $tokens = $ctx->stash('tokens');
    my $builder = $ctx->stash('builder');
    local $ctx->{__stash}{'blog'} = $blog;
    local $ctx->{__stash}{'blog_id'} = $blog->id;
    
    local $ctx->{__stash}{'entry'} = MT::Entry->load( $entry_id ) if ( ( $entry_id ) && ( $mode eq 'view' ) 
                                                                    && ( ( $type eq 'entry') || ( $type eq 'page') ) );
    my $out = $builder->build($ctx, $tokens, $cond);
    $out;
}

1;